// https://www.mathematik.uni-marburg.de/~gumm/Lehre/SS07/PraktischeInformatikII/Folien/05%20StacksQueues.pdf

class TECharStack {
	char[] values;
	int current;

	TECharStack() {
		values = new char[10];
		current = -1;
	}

	boolean isEmpty() {
		return current == -1;
	}

	void push(char value) {
		ensureCapacity();
		values[++current] = value;
	}

	char pop() {
		if (isEmpty()) {
			throw new RuntimeException();
		}
		return values[this.current--];
	}

	char peek() {
		if (isEmpty()) {
			throw new RuntimeException();
		}
		return values[current];
	}

	void ensureCapacity() {
		if (current == values.length - 1) {
			char[] help = new char[values.length * 2];
			for (int i = 0; i < values.length; i++) {
				help[i] = values[i];
			}
			values = help;
		}
	}
}

public class UE13Aufgabe20 {

	TECharStack left = new TECharStack();
	TECharStack right = new TECharStack();

	void left() {
		if (!left.isEmpty()) {
			right.push(left.pop());
		}
	}

	void right() {
		if (!right.isEmpty()) {
			left.push(right.pop());
		}
	}

	void delete() {
		if (!left.isEmpty()) {
			left.pop();
		}
	}

	void type(char ch) {
		left.push(ch);
	}

	String getTextAndClear() {
		String result = "";
		while (!left.isEmpty()) {
			result = left.pop() + result;
		}
		while (!right.isEmpty()) {
			result = result + right.pop();
		}
		return result;
	}

	public static void main(String[] args) {
		UE13Aufgabe20 editor = new UE13Aufgabe20();
		editor.type('h');
		editor.type('e');
		editor.type('w');
		editor.type('o');
		editor.left();
		editor.left();
		editor.type('l');
		editor.type('l');
		editor.type('o');
		editor.type(' ');
		editor.right();
		editor.right();
		editor.type('r');
		editor.type('l');
		editor.type('d');
		editor.type('!');
		System.out.println(editor.getTextAndClear());
	}

}
